VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "SYNC_Protocol"
   ClientHeight    =   4575
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   4575
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox Combo_Board 
      Height          =   315
      ItemData        =   "Form1.frx":0000
      Left            =   1080
      List            =   "Form1.frx":0034
      TabIndex        =   11
      Top             =   120
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Baud 
      Height          =   315
      ItemData        =   "Form1.frx":006E
      Left            =   1080
      List            =   "Form1.frx":008A
      TabIndex        =   10
      Top             =   480
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Node 
      Height          =   315
      ItemData        =   "Form1.frx":00F0
      Left            =   1080
      List            =   "Form1.frx":0271
      TabIndex        =   9
      Top             =   840
      Width           =   1575
   End
   Begin VB.CommandButton Btn_Initial 
      Caption         =   "Initial Master"
      Height          =   375
      Left            =   2760
      TabIndex        =   8
      Top             =   480
      Width           =   1815
   End
   Begin VB.CommandButton Btn_AddNode 
      Caption         =   "Add Node"
      Height          =   375
      Left            =   2760
      TabIndex        =   7
      Top             =   840
      Width           =   1815
   End
   Begin VB.Frame Pal_SYNC 
      Height          =   3255
      Left            =   120
      TabIndex        =   0
      Top             =   1200
      Width           =   4455
      Begin VB.CommandButton Btn_SendSYNC 
         Caption         =   "Send SYNC"
         Height          =   375
         Left            =   2520
         TabIndex        =   19
         Top             =   840
         Width           =   1815
      End
      Begin VB.TextBox Text_SYNCID 
         Height          =   285
         Left            =   1320
         TabIndex        =   17
         Text            =   "80"
         Top             =   240
         Width           =   975
      End
      Begin VB.TextBox Text_SYNCTimer 
         Height          =   285
         Left            =   120
         TabIndex        =   4
         Text            =   "1000"
         Top             =   960
         Width           =   975
      End
      Begin VB.TextBox Text_SYNCTimes 
         Height          =   285
         Left            =   1320
         TabIndex        =   3
         Text            =   "00"
         Top             =   960
         Width           =   975
      End
      Begin VB.CommandButton Btn_SYNCID 
         Caption         =   "Change SYNC ID"
         Height          =   375
         Left            =   2520
         TabIndex        =   2
         Top             =   240
         Width           =   1815
      End
      Begin VB.ListBox List_SYNCID 
         Height          =   1815
         ItemData        =   "Form1.frx":055C
         Left            =   120
         List            =   "Form1.frx":055E
         TabIndex        =   1
         Top             =   1320
         Width           =   4215
      End
      Begin VB.Label Label6 
         Caption         =   "Send Times"
         Height          =   255
         Left            =   1320
         TabIndex        =   18
         Top             =   720
         Width           =   975
      End
      Begin VB.Label Label4 
         Caption         =   " SYNC ID (hex)"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Width           =   1095
      End
      Begin VB.Label Label5 
         Caption         =   $"Form1.frx":0560
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   720
         Width           =   975
      End
   End
   Begin VB.CommandButton Btn_Shutdown 
      Caption         =   "Shutdown"
      Height          =   375
      Left            =   2760
      TabIndex        =   12
      Top             =   480
      Width           =   1815
   End
   Begin VB.CommandButton Btn_Remove 
      Caption         =   "Remove Node"
      Height          =   375
      Left            =   2760
      TabIndex        =   13
      Top             =   840
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "Board No."
      Height          =   255
      Left            =   120
      TabIndex        =   16
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Baud Rate"
      Height          =   255
      Left            =   120
      TabIndex        =   15
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label3 
      Caption         =   "Node ID"
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   840
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim BOARD As Byte
Dim BAUD As Byte
Dim Node As Byte
 
Const BlockMode As Byte = 1

Dim IsAdd(128) As Byte
    
Dim DelayTime As Integer
Dim ret As Integer
Dim errstr As String

Private Sub UpdataList()
    Dim a_SyncId(5) As Integer, a_Timer(5) As Integer
    Dim a_Times(5) As Long

    Call List_SYNCID.Clear

    ret = CPM100_GetCyclicSYNCInfo(BOARD, a_SyncId(0), a_Timer(0), a_Times(0), BlockMode)
    If ret = 0 Then
        Dim i As Integer
        Dim Temp_Str As String

        For i = 0 To 4
            If a_SyncId(i) = 0 Then
                Exit For
            End If

            Temp_Str = "SYNC: " + Right("00" & Hex(a_SyncId(i)), 3) + " , Timer: " + Str(a_Timer(i)) + " , Times: " + Str(a_Times(i))
            Call List_SYNCID.AddItem(Temp_Str)
        Next
    End If
End Sub

Private Sub Btn_AddNode_Click()
    ret = CPM100_AddNode(BOARD, Node, 1, DelayTime, 200, BlockMode)
    If ret <> 0 Then
        errstr = "AddNode Error, = " + Str(ret)
        Call MsgBox(errstr)
    Else
        Dim SyncId As Integer

        SyncId = 0
        IsAdd(Node) = 1

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = False
        Btn_Remove.Enabled = True

        Pal_SYNC.Enabled = True

        ret = CPM100_GetSYNCID(BOARD, Node, SyncId, BlockMode)
        If ret = 0 Then
            Text_SYNCID.Text = Hex(SyncId)
        End If
    End If
End Sub

Private Sub Btn_Initial_Click()
    ret = CPM100_InitMaster(BOARD, 0, BAUD, BlockMode)
    If ret <> 0 Then
        errstr = "Initial Error, = " + Str(ret)
        Call MsgBox(errstr)
    Else
        Combo_Board.Enabled = False
        Combo_Baud.Enabled = False
        Combo_Node.Enabled = True

        Btn_Initial.Enabled = False
        Btn_Initial.Visible = False
        Btn_Shutdown.Enabled = True

        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
    End If
End Sub

Private Sub Btn_Remove_Click()
    ret = CPM100_RemoveNode(BOARD, Node, BlockMode)
    If ret <> 0 Then
        errstr = "RemoveNode Error, = " + Str(ret)
        Call MsgBox(errstr)
    Else
        IsAdd(Node) = 0

        Btn_Remove.Enabled = False
        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True

        Pal_SYNC.Enabled = False

        Text_SYNCID.Text = ""

        Call UpdataList

    End If
End Sub

Private Sub Btn_SendSYNC_Click()
    Dim SyncId As Integer, Timer As Integer
    Dim Times As Long

    SyncId = Val("&H" & Text_SYNCID.Text)
    Timer = Val(Text_SYNCTimer.Text)
    Times = Val(Text_SYNCTimes.Text)

    ret = CPM100_SendSYNCMsg(BOARD, SyncId, Timer, Times, BlockMode)
    If ret <> 0 Then
        errstr = "SendSYNCMsg Error, = " + Str(ret)
        Call MsgBox(errstr)
    Else
        Call UpdataList
    End If
End Sub

Private Sub Btn_Shutdown_Click()
    Dim i As Integer

    i = 0
    ret = CPM100_ShutdownMaster(BOARD)
    If ret <> 0 Then
        errstr = "Shutdown Error, = " + Str(ret)
        Call MsgBox(errstr)
    Else
        Combo_Board.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Btn_Initial.Enabled = True
        Btn_Initial.Visible = True
        Btn_Shutdown.Enabled = False

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False

        Pal_SYNC.Enabled = False

        Call List_SYNCID.Clear

        For i = 0 To 128
            IsAdd(i) = 0
        Next
    End If
End Sub

Private Sub Btn_SYNCID_Click()
    Dim SyncId As Integer

    SyncId = Val("&H" & Text_SYNCID.Text)

    ret = CPM100_ChangeSYNCID(BOARD, Node, SyncId, BlockMode)
    If ret <> 0 Then
        errstr = "ChangeSYNCID Error, = " + Str(ret)
        Call MsgBox(errstr)
    End If

    ret = CPM100_GetSYNCID(BOARD, Node, SyncId, BlockMode)
    If ret = 0 Then
        Text_SYNCID.Text = Hex(SyncId)
    End If
End Sub

Private Sub Combo_Baud_LostFocus()
    
    BAUD = Combo_Baud.ListIndex
    Select Case (BAUD)
        Case 0
            DelayTime = 15
        Case 1
            DelayTime = 7
        Case 2
            DelayTime = 3
        Case 3
        Case 4
            DelayTime = 1
        Case 5
        Case 6
        Case 7
            DelayTime = 0
    End Select
End Sub

Private Sub Combo_Board_LostFocus()
    BOARD = (Combo_Board.ListIndex)
End Sub

Private Sub Combo_Node_LostFocus()
    Node = Combo_Node.ListIndex + 1
    
    If IsAdd(Node) <> 0 Then
        Dim SyncId As Integer
    
        SyncId = 0
        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = False
        Btn_Remove.Enabled = True
    
        Pal_SYNC.Enabled = True
    
        ret = CPM100_GetSYNCID(BOARD, Node, SyncId, BlockMode)
        If ret = 0 Then
            Text_SYNCID.Text = Hex(SyncId)
        End If
    Else
        Btn_Remove.Enabled = False
        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
    
        Pal_SYNC.Enabled = False
    
        Text_SYNCID.Text = ""
    End If
End Sub

Private Sub Form_Load()
    Dim i As Integer

    BOARD = 0
    BAUD = 0
    Node = 1

    Combo_Board.Enabled = True
    Combo_Baud.Enabled = True
    Combo_Node.Enabled = False

    Combo_Board.ListIndex = 0
    Combo_Baud.ListIndex = 0
    Combo_Node.ListIndex = 0

    Btn_AddNode.Enabled = False
    Btn_AddNode.Visible = True
    Btn_Remove.Enabled = False

    Pal_SYNC.Enabled = False

    For i = 0 To 128
        IsAdd(i) = 0
    Next
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call CPM100_ShutdownMaster(BOARD)
End Sub
