VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "PDO_MultiData"
   ClientHeight    =   4290
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   4290
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   3480
      Top             =   0
   End
   Begin VB.ListBox List_PDOData 
      Height          =   1815
      Left            =   120
      TabIndex        =   13
      Top             =   2280
      Width           =   4455
   End
   Begin VB.CommandButton Btn_SetPolling 
      Caption         =   $"Form1.frx":0000
      Height          =   735
      Left            =   2760
      TabIndex        =   11
      Top             =   1440
      Width           =   1815
   End
   Begin VB.CommandButton Btn_SetEventTimer 
      Caption         =   $"Form1.frx":0028
      Height          =   735
      Left            =   120
      TabIndex        =   10
      Top             =   1440
      Width           =   1815
   End
   Begin VB.CommandButton Btn_AddNode 
      Caption         =   "Add Node"
      Height          =   375
      Left            =   2760
      TabIndex        =   4
      Top             =   840
      Width           =   1815
   End
   Begin VB.CommandButton Btn_Initial 
      Caption         =   "Initial Master"
      Height          =   375
      Left            =   2760
      TabIndex        =   3
      Top             =   480
      Width           =   1815
   End
   Begin VB.ComboBox Combo_Node 
      Height          =   315
      ItemData        =   "Form1.frx":004B
      Left            =   1080
      List            =   "Form1.frx":01CC
      TabIndex        =   2
      Top             =   840
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Baud 
      Height          =   315
      ItemData        =   "Form1.frx":04B7
      Left            =   1080
      List            =   "Form1.frx":04D3
      TabIndex        =   1
      Top             =   480
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Board 
      Height          =   315
      ItemData        =   "Form1.frx":0539
      Left            =   1080
      List            =   "Form1.frx":056D
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.CommandButton Btn_Shutdown 
      Caption         =   "Shutdown"
      Height          =   375
      Left            =   2760
      TabIndex        =   5
      Top             =   480
      Width           =   1815
   End
   Begin VB.CommandButton Btn_Remove 
      Caption         =   "Remove Node"
      Height          =   375
      Left            =   2760
      TabIndex        =   6
      Top             =   840
      Width           =   1815
   End
   Begin VB.Label Label4 
      Caption         =   "Or"
      Height          =   255
      Left            =   2280
      TabIndex        =   12
      Top             =   1680
      Width           =   375
   End
   Begin VB.Label Label3 
      Caption         =   "Node ID"
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   840
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Baud Rate"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Board No."
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Board As Byte
Dim BAUD As Byte
Dim Node As Byte
 
Const BlockMode As Byte = 1

Dim Id_List(10) As Integer
Dim PDO_Cnt As Byte

Dim DelayTime As Integer
Dim ret As Integer
Dim errstr As String

Private Sub Btn_AddNode_Click()
    ret = CPM100_AddNode(Board, Node, 1, DelayTime, 200, BlockMode)
    If (ret <> 0) Then
        errstr = "AddNode Error, = " + Str(ret)
        Call MsgBox(errstr)
    Else
        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = False
        Btn_Remove.Enabled = True
        Combo_Node.Enabled = False

        ret = CPM100_GetTxPDOID(Board, Node, PDO_Cnt, Id_List(0), BlockMode)
        If (ret <> 0) Then
            errstr = "GetTxPDOID Error, = " + Str(ret)
            Call MsgBox(errstr)

            Btn_SetEventTimer.Enabled = False
            Btn_SetPolling.Enabled = False
        Else
            Btn_SetEventTimer.Enabled = True
            Btn_SetPolling.Enabled = True
            Timer1.Enabled = True
        End If
    End If
End Sub

Private Sub Btn_Initial_Click()
    ret = CPM100_InitMaster(Board, 0, BAUD, BlockMode)
    If (ret <> 0) Then
        errstr = "Initial Error, = " + Str(ret)
        Call MsgBox(errstr)
    Else
        Combo_Board.Enabled = False
        Combo_Baud.Enabled = False
        Combo_Node.Enabled = True

        Btn_Initial.Enabled = False
        Btn_Initial.Visible = False
        Btn_Shutdown.Enabled = True

        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
    End If
End Sub

Private Sub Btn_Remove_Click()
    ret = CPM100_RemoveNode(Board, Node, BlockMode)
    If (ret <> 0) Then
        errstr = "RemoveNode Error, = " + Str(ret)
        Call MsgBox(errstr)
    Else
        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False
        Combo_Node.Enabled = True

        Btn_SetEventTimer.Enabled = False
        Btn_SetPolling.Enabled = False

        Timer1.Enabled = False
    End If
End Sub

Private Sub Btn_SetEventTimer_Click()
    Dim i As Integer
    Dim Temp_Str As String
    Dim CobId(0) As Integer

    CobId(0) = 0
    ret = CPM100_SetPDORemotePolling(Board, 0, CobId(0), 100, BlockMode)  ' Remove PDO-Polling
    If (ret <> 0) Then
        Temp_Str = "Stop TxPDO Polling Error, = " + Str(ret)
        Call MsgBox(errstr)
    End If

    If PDO_Cnt <> 0 Then
        For i = 0 To PDO_Cnt - 1
            ret = CPM100_PDOEventTimer(Board, Id_List(i), 500, BlockMode)
            If (ret <> 0) Then
                Temp_Str = "The PDO " + Right("00" & Hex(Id_List(i)), 3) + " Not Support Event Timer"
                Call MsgBox(Temp_Str)
            End If
        Next i
    End If
End Sub

Private Sub Btn_SetPolling_Click()
    Dim i As Integer
    Dim Temp_Str As String

    If PDO_Cnt <> 0 Then
        For i = 0 To PDO_Cnt - 1
            ret = CPM100_PDOEventTimer(Board, Id_List(i), 0, BlockMode)   ' Stop PDO Event Timer
            If (ret <> 0) Then
                Temp_Str = "Stop The PDO " + Right("00" & Hex(Id_List(i)), 3) + " Event Timer Error, = " + Str(ret)
                Call MsgBox(Temp_Str)
            End If
        Next i
    End If

    ret = CPM100_SetPDORemotePolling(Board, PDO_Cnt, Id_List(0), 100, BlockMode)
    If (ret <> 0) Then
        Temp_Str = "Set Polling All TxPDO Error, = " + Str(ret)
        Call MsgBox(Temp_Str)
    End If
End Sub

Private Sub Btn_Shutdown_Click()
    ret = CPM100_ShutdownMaster(Board)
    If (ret <> 0) Then
        errstr = "Shutdown Error, = " + Str(ret)
        Call MsgBox(errstr)
    Else
        Combo_Board.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Btn_Initial.Enabled = True
        Btn_Initial.Visible = True
        Btn_Shutdown.Enabled = False

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False

        Btn_SetEventTimer.Enabled = False
        Btn_SetPolling.Enabled = False

        Timer1.Enabled = False
    End If
End Sub

Private Sub Combo_Baud_LostFocus()
    
    BAUD = Combo_Baud.ListIndex
    Select Case (BAUD)
        Case 0
            DelayTime = 15
        Case 1
            DelayTime = 7
        Case 2
            DelayTime = 3
        Case 3
        Case 4
            DelayTime = 1
        Case 5
        Case 6
        Case 7
            DelayTime = 0
    End Select
End Sub

Private Sub Combo_Board_LostFocus()
    Board = (Combo_Board.ListIndex)
End Sub

Private Sub Combo_Node_LostFocus()
    Node = Combo_Node.ListIndex + 1
End Sub

Private Sub Form_Load()
    Board = 0
    BAUD = 0
    Node = 1

    Combo_Board.Enabled = True
    Combo_Baud.Enabled = True
    Combo_Node.Enabled = False

    Combo_Board.ListIndex = 0
    Combo_Baud.ListIndex = 0
    Combo_Node.ListIndex = 0

    Btn_AddNode.Enabled = False
    Btn_AddNode.Visible = True
    Btn_Remove.Enabled = False
    Btn_SetEventTimer.Enabled = False
    Btn_SetPolling.Enabled = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Timer1.Enabled = False
    Call CPM100_ShutdownMaster(Board)
End Sub

Private Sub Timer1_Timer()
    Dim i As Integer, j As Integer
    Dim Temp_Str As String

    Dim IsNew(10) As Byte
    Dim DLen(10) As Byte
    Dim Data(8 * 10) As Byte

    ret = CPM100_GetMultiPDOData(Board, PDO_Cnt, Id_List(0), IsNew(0), DLen(0), Data(0), 0)
    If (ret = 0) Then
        Dim startaddr As Integer

        Call List_PDOData.Clear

        If PDO_Cnt <> 0 Then
            For i = 0 To PDO_Cnt - 1
                Temp_Str = "TxPDO " + Hex(Id_List(i)) + " : "
                startaddr = (i * 8)
                 
                If DLen(i) <> 0 Then
                    For j = 0 To DLen(i) - 1
                        Temp_Str = Temp_Str + Right("0" & Hex(Data(startaddr + j)), 2) + " "
                    Next j
                End If

                Call List_PDOData.AddItem(Temp_Str)
            Next i
        End If
    End If
End Sub
